#include "ItsRSUsSimulator_Functions.hh"

#include "loggers.hh"
#include "geospacial.hh"

namespace ItsRSUsSimulator__Functions {
  void fx__computePositionFromRotation(const INTEGER &p__refLatitude, const INTEGER &p__refLongitude, const INTEGER &p__cenLatitude,
                                       const INTEGER &p__cenLongitude, const INTEGER &p__rotation, INTEGER &p__latitude, INTEGER &p__longitude) {
    // TODO
    p__latitude  = p__cenLatitude;
    p__longitude = p__cenLongitude;
  }

  void fx__computeIncPosition(const INTEGER &p__refLatitude, const INTEGER &p__refLongitude, const FLOAT& p__dx, const FLOAT& p__dy, INTEGER &p__new__latitude, INTEGER &p__new__longitude) {
    // Assume that As long as p__dx and p__dy are small compared to the radius of the earth and reference position is not too close to the pole
    // http://www.edwilliams.org/avform147.htm#Intro
    loggers::get_instance().log_msg(">>> fx__computeIncPosition: p__refLatitude=", p__refLatitude);
    loggers::get_instance().log_msg(">>> fx__computeIncPosition: p__refLongitude=", p__refLongitude);

    //loggers::get_instance().log("fx__computeIncPosition: lat='%f'", static_cast<const int>(p__refLatitude)  + (p__dy / R) * (180 / PI));
    //loggers::get_instance().log("fx__computeIncPosition: long='%f'", static_cast<const int>(p__refLongitude) + (p__dx / R) * (180 / PI) / cos(static_cast<const int>(p__refLatitude) * PI / 180));
    p__new__latitude  = p__refLatitude + 1;//static_cast<const int>(static_cast<const int>(p__refLatitude)  + (p__dy / R) * (180 / PI));
    p__new__longitude = p__refLongitude + 1;//static_cast<const int>(static_cast<const int>(p__refLongitude) + (p__dx / R) * (180 / PI) / cos(static_cast<const int>(p__refLatitude) * PI / 180));

    loggers::get_instance().log_msg("<<< fx__computeIncPosition: p__refLatitude=", p__new__latitude);
    loggers::get_instance().log_msg("<<< fx__computeIncPosition: p__refLongitude=", p__new__longitude);

  }

} // namespace ItsRSUsSimulator__Functions
