#!/bin/bash

#set -e
set -vx

export ASN1CDIR=/home/etsi/frameworks/asn1c

echo -e "*****************************\n* Build ETSI ITS certificate generation tools \n*****************************\n"
cd ${HOME}/dev || exit 1

git clone --recurse-submodules --branch release2 https://forge.etsi.org/rep/ITS/itscertgen.git ./itscertgen
cd ./itscertgen
sed --in-place 's/\-fillabs2//g' ./certgen/asncodec/Makefile
make && cd - || exit 1

echo -e "*****************************\n* Generate ETSI ITS certificates \n*****************************\n"
cd ${HOME}/dev/TS.ITS/data/certificates
CERTGEN=${HOME}/dev/itscertgen make
CERTGEN=${HOME}/dev/itscertgen make install

cd ${HOME}

exit 0

